#!/usr/bin/env python

from __future__ import division

import sys
import scrypt

from time import time
from struct import pack, unpack

def verify(nonce, target, counter):
    return unpack('!L', scrypt.hash(nonce, pack('!Q', counter), N=4096, r=2, p=1, buflen=4))[0] <= target

def generate(nonce, target):
    counter = int(time())*1000000000
    while True:
        if verify(nonce, target, counter):
            return counter
        counter += 1

if __name__ == '__main__':
    print generate(sys.argv[1], long(sys.argv[2]))
